ALTER TABLE FK_DOKUMENTY
ADD KWOTA NUMERIC(12,2);

/*--------------------------------------------------------------- */
SET TERM ^ ;

CREATE PROCEDURE KWOTA_DOK (
    id integer)
returns (
    suma numeric(12,2))
as
begin
  for select sum(t.KWOTA) as KWOTA from FK_TERMINY t where T.ID_DOKUMENTY= :ID
  into  :SUMA
  do
  begin
    suspend;
  end

end^

SET TERM ; ^

GRANT SELECT ON FK_TERMINY TO PROCEDURE KWOTA_DOK;

GRANT EXECUTE ON PROCEDURE KWOTA_DOK TO SYSDBA;

/*--------------------------------------------------------------- */

SET TERM ^ ;


CREATE TRIGGER TRIG_TERMINY FOR FK_TERMINY
ACTIVE AFTER INSERT OR UPDATE POSITION 0
AS
DECLARE VARIABLE suma NUMERIC(12,2);
begin
  /*Ustawia suma w polu  KWOTA w tabeli FK_DOKUMENTY  */

  EXECUTE PROCEDURE KWOTA_DOK(NEW.ID_DOKUMENTY)
  RETURNING_VALUES :suma;

  update FK_DOKUMENTY  set KWOTA =:suma where ID = NEW.ID_DOKUMENTY ;

end
^


SET TERM ; ^

/*--------------------------------------------------------------- */
